module Revisions
  class ApplicationController < ActionController::Base
    protect_from_forgery with: :null_session
    attr_accessor :current_user

    before_action :authenticate_user

    def authenticate_user
      user = Revisions::User.find_by_id(params[:uid])
      if !user || !ActiveSupport::SecurityUtils.secure_compare(user.key, params[:key])
        render_unauthorized
        return
      end
      self.current_user = user
    end

    def build_url(path)
      "#{Revisions.mount_host}/#{params[:user_key]}/#{params[:email]}/#{Revisions.mount_name}/#{path}"
    end

    def render_unauthorized
      render :json => {:error => {:tag => "unauthorized", :message => "You are unauthorized to access this page."}}, :status => 401
    end
  end
end
