require_dependency "revisions/application_controller"

module Revisions
  class ExtensionController < ApplicationController

    def index
      key = params[:key]
      actions = []

      item_uuid = params[:item_uuid]
      if item_uuid
        item = current_user.items.find_by_item_uuid(item_uuid)
      end

      if item
        item.revisions.each_with_index do |rev, index|
            action = {
              :label => "#{rev.created_at.strftime('%a %b %d, %Y at %I:%M%p %Z')}" + (index == 0 ? " (current)" : ""),
              :desc => "",
              :verb => "nested",
              :context => "Item",
              :content_types => ["Note"],
              :subactions => [
                {
                  :label => "Preview",
                  :desc => "",
                  :url => build_url("#{rev.id}?uid=#{params[:uid]}&key=#{params[:key]}"),
                  :verb => "render",
                },
                {
                  :label => "Restore",
                  :desc => "",
                  :url => build_url("#{rev.id}?uid=#{params[:uid]}&key=#{params[:key]}"),
                  :verb => "get",
                }
              ]
            }
            actions.push(action)
          end
        end

        render :json => {
          :name => "Note History",
          :supported_types => [:Note],
          :actions => actions,
          deprecation: 'This extension will soon be replaced by Remote History, accessible via the History menu.'
        }
    end

  end
end
