require_dependency 'revisions/application_controller'

module Revisions
  class ItemsController < ApplicationController
    def save
      items = params[:items]
      auth_params = params[:auth_params]
      directive = params[:directive]

      if directive == 'delete-account'
        current_user.destroy
        head :no_content
        return
      end

      items.each do |item_hash|
        item = current_user.items.find_or_create_by(item_uuid: item_hash['uuid'])

        if item_hash['deleted'] == true
          item.destroy
          head :no_content
          next
        end

        item.prune_history

        item.add_revision(
          items_key_id: item_hash['items_key_id'],
          duplicate_of: item_hash['duplicate_of'],
          content: item_hash['content'],
          enc_item_key: item_hash['enc_item_key'],
          auth_hash: item_hash['auth_hash'],
          auth_params: auth_params
        )
        if item.content_type.nil?
          item.content_type = item_hash['content_type']
          item.save
        end
      end

      head :no_content
    end
  end
end
