require_dependency "revisions/application_controller"

module Revisions
  class RevisionsController < ApplicationController

    def show
      revision = Revision.find(params[:id])
      if revision.item.user_id != current_user.id
        render_unauthorized
        return
      end

      if revision.auth_params
        # Handles issue where auth params were not previously properly serialized before being inserted
        begin
          auth_params = JSON.parse(revision.auth_params)
        rescue
          auth_params = JSON.parse(revision.auth_params.gsub('=>', ':'))
        end
      end

      render :json => {
        :item => revision.as_json.merge({:uuid => revision.item.item_uuid, :content_type => revision.item.content_type}),
        :auth_params => auth_params
      }
    end

  end
end
